/*
 * QUSOFT MICROSYSTMES
 * Assembly Studio for MVS
 * Copyright 2004 Frdric Brown
 */

/*
 *  This file is part of Assembly Studio for MVS.
 *
 *  Assembly Studio for MVS is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Assembly Studio for MVS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with Assembly Studio for MVS; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import moka.lang.System;//Import the class moka.lang.System
import moka.lang.String;//Import the class moka.lang.String
import moka.x.Frame;//Import the class moka.x.Frame
import moka.x.TextArea;//Import the class moka.x.Frame
import moka.x.Button;//Import the class moka.x.Frame

/**
 *
 *
 * @author  Frdric Brown
 */
public class FrameASM extends Frame {
	private GuiASM frameCode;
	protected TextArea txtASM;
	private Button btnASM;

	public FrameASM (GuiASM frameCode) {
		super("Assembler");

		if (System.CALCULATOR) {
			this.setBounds(0, 0, 200, 100);
		}
		else {
			this.setBounds(0, 0, 120, 90);
		}
		this.defaultCloseOperation = Frame.HIDE_ON_CLOSE;

		this.txtASM = new TextArea();

		if (System.CALCULATOR) {
			this.txtASM.setBounds(5, 15, 190, 60);
		}
		else {
			this.txtASM.setBounds(5, 15, 110, 50);
		}

		this.txtASM.warp = false;
		this.txtASM.vScrollVisible = true;
		this.add(this.txtASM);

		this.btnASM = new Button("ASM");
		this.btnASM.setBounds(5, this.height - 20, 40, 15);
		this.btnASM.mnemonic = 'A';
		this.btnASM.listen = this;
		this.add(this.btnASM);

		this.frameCode = frameCode;
	}

	public void eventTriggered(Object sender) {
		if (sender == this.btnASM) {
			this.frameCode.setCodeFromASM(this.txtASM.caption);
			this.frameCode.setVisible(true);
			GEM.gem.toFront(this.frameCode);
		}
	}

	public void setASMFromCode(String code) {
		String codeASM = "";

		char * exprP = code.value;
		native {
			char * endP = &exprP[strlen(exprP)];
		}
		ubyte opCode;

		while (exprP < endP) {

			opCode = DisASM.getByte(exprP, 8);
			exprP += 2;

			if (opCode < 0x40) {
				if ((exprP + 2) > endP) {
					break;
				}
			}
			else if (opCode < 0xC0) {
				if ((exprP + 6) > endP) {
					break;
				}
			}
			else {
				if ((exprP + 10) > endP) {
					break;
				}
			}

			if (DisASM.opVecStr[opCode]) {
				codeASM += DisASM.opVecForm[opCode].print(opCode, exprP);
				codeASM += '\n';

			}
			else {
				codeASM += "OpCode inconnu : 0x";
				codeASM += DisASM.printHex8(opCode);
				codeASM += '\n';
			}

			if (opCode < 0x40) {
				exprP += 2;
			}
			else if (opCode < 0xC0) {
				exprP += 6;
			}
			else {
				exprP += 10;
			}
		}

		this.txtASM.setCaption(codeASM);
	}
}