/*
 * QUSOFT MICROSYSTMES
 * Assembly Studio for MVS
 * Copyright 2004 Frdric Brown
 */

/*
 *  This file is part of Assembly Studio for MVS.
 *
 *  Assembly Studio for MVS is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Assembly Studio for MVS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with Assembly Studio for MVS; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import moka.lang.System;//Import the class moka.lang.System
import moka.lang.String;//Import the class moka.lang.String
import moka.x.Frame;//Import the class moka.x.Frame
import moka.x.TextArea;//Import the class moka.x.Frame
import moka.x.Button;//Import the class moka.x.Frame
import moka.x.Font;//Import the class moka.x.Frame

/**
 *
 *
 * @author  Frdric Brown
 */
public class FrameAbout extends Frame {
	private TextArea txtAbout;
	private Button btnOk;

	public FrameAbout () {
		super("ASM Studio");

		this.setBounds(0, 0, 120, 90);

		this.defaultCloseOperation = Frame.HIDE_ON_CLOSE;

		this.txtAbout = new TextArea();

		this.txtAbout.setBounds(5, 15, 110, 50);

		this.txtAbout.warp = false;

		this.txtAbout.font = Font.FONT_4x6;

		this.txtAbout.setCaption("//FB1ABOUT JOB\n//CREDITS PGM=AUTHOR\n//SYSIN DD *\n  Frdric Brown\n  (c) 2004 Qusoft\n           microsystmes\n/*");

		this.txtAbout.enabled = false;

		this.add(this.txtAbout);

		this.btnOk = new Button("Ok");
		this.btnOk.mnemonic = 'O';
		this.btnOk.listen = this;
		this.add(this.btnOk);

		this.btnOk.setBounds(0, 0, 20, 15);
		this.btnOk.center();
		this.btnOk.setY(this.height - 20);
	}

	public void eventTriggered(Object sender) {
		if (sender == this.btnOk) {
			this.setVisible(false);
		}
	}
}