//Defining class CaptionedComponent
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */
/*
 *  This file is part of Moka API.
 *
 *  Moka API is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka API is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Moka API; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * The CaptionedComponent class represents a component that shows a caption.
 *
 * @author  Frdric Brown
 * @version 1.0, 2002-11-13
 * @since   MDK1.0a
 */
TCaptionedComponent * TCaptionedComponent0 ( ) {
	TCaptionedComponent * this = malloc ( sizeof ( TCaptionedComponent ) ) ; 
	this -> class = ( char * ) "CaptionedComponent" ; 
	this -> class_id = 23 ; 
	this -> super = ( void * ) Component ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	//Methods from class EventListener
	//Methods from class Component
	this -> eventTriggered_Object = ( void * ) TComponent_eventTriggered_Object ; 
	this -> onPaint_ = ( void * ) TComponent_onPaint_ ; 
	this -> paint_ = ( void * ) TComponent_paint_ ; 
	this -> setBounds_short_int_short_int_short_int_short_int = ( void * ) TComponent_setBounds_short_int_short_int_short_int_short_int ; 
	this -> setY_short_int = ( void * ) TComponent_setY_short_int ; 
	this -> move_short_int_short_int = ( void * ) TComponent_move_short_int_short_int ; 
	this -> setVisible_BOOL = ( void * ) TComponent_setVisible_BOOL ; 
	this -> use_ = ( void * ) TComponent_use_ ; 
	this -> isCursorOver_short_int_short_int = ( void * ) TComponent_isCursorOver_short_int_short_int ; 
	this -> center_ = ( void * ) TComponent_center_ ; 
	this -> toFront_Component = ( void * ) TComponent_toFront_Component ; 
	this -> clean_ = ( void * ) TComponent_clean_ ; 
	this -> checkMnemonic_char = ( void * ) TComponent_checkMnemonic_char ; 
	//Methods from class CaptionedComponent
	this -> finalize_ = ( void * ) TCaptionedComponent_finalize_ ; 
	this -> setCaption_String = ( void * ) TCaptionedComponent_setCaption_String ; 
	this -> setFont_short_int = ( void * ) TCaptionedComponent_setFont_short_int ; 
	return this ; 
} 
/*
	 * Constructs a new CaptionedComponent specifying its caption.
	 *
	 * @param caption the CaptionedComponent's caption.
	 */
TCaptionedComponent * TCaptionedComponent_String ( struct String * caption ) {
	TCaptionedComponent * this = TCaptionedComponent0 ( ) ; 
	CaptionedComponent__String ( this , caption ) ; 
	return this ; 
} 
void CaptionedComponent__String ( struct CaptionedComponent * this , struct String * caption ) { 
	Component__ ( ( TComponent *  ) this ) ; 
	this -> caption = caption ; 
	this -> font = Font_FONT_SYSTEM ; 
	
} 
/**
     * Free the memory and system ressources used by this CaptionedComponent.
     */
void TCaptionedComponent_finalize_ ( struct CaptionedComponent * this ) { 
	this -> caption -> finalize_ ( this -> caption ) ; 
	Component -> finalize_ ( this ) ; 
	
} 
/**
 	 * Sets the caption of the component.
 	 *
 	 * @param caption The caption of the component.
 	 */
void TCaptionedComponent_setCaption_String ( struct CaptionedComponent * this , struct String * caption ) { 
	this -> caption -> finalize_ ( this -> caption ) ; 
	this -> caption = caption ; 
	this -> repaint = TRUE ; 
	if ( this -> visible && this -> parent ) { 
		this -> parent -> onRefresh_ ( this -> parent ) ; 
		
	} 
	
} 
/**
	 * Sets the font for this component's caption.
	 * 
	 * @param font the font for this component's caption.
	 */
void TCaptionedComponent_setFont_short_int ( struct CaptionedComponent * this , short int font ) { 
	this -> font = font ; 
	this -> repaint = TRUE ; 
	if ( this -> visible && this -> parent ) { 
		this -> parent -> onRefresh_ ( this -> parent ) ; 
		
	} 
	
} 
