//Defining class FormatRS2
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Assembly Studio for MVS
 * Copyright 2004 Frdric Brown
 */
/*
 *  This file is part of Assembly Studio for MVS.
 *
 *  Assembly Studio for MVS is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Assembly Studio for MVS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with Assembly Studio for MVS; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
//Import the class moka.lang.System
//Import the class moka.lang.String
/**
 * Format OpCode R1,M3,D2(B2)
 *
 * @author  Frdric Brown
 */
TFormatRS2 * TFormatRS20 ( ) {
	TFormatRS2 * this = malloc ( sizeof ( TFormatRS2 ) ) ; 
	this -> class = ( char * ) "FormatRS2" ; 
	this -> class_id = 6 ; 
	this -> super = ( void * ) Format ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	this -> finalize_ = ( void * ) TObject_finalize_ ; 
	//Methods from class Format
	//Methods from class FormatRS2
	this -> print_unsigned_byte_char_p = ( void * ) TFormatRS2_print_unsigned_byte_char_p ; 
	this -> assemble_unsigned_byte_char_p = ( void * ) TFormatRS2_assemble_unsigned_byte_char_p ; 
	return this ; 
} 

TString *  TFormatRS2_print_unsigned_byte_char_p ( struct FormatRS2 * this , unsigned byte opCode , char * exprP ) { 
	NYBBLE R1 ; 
	NYBBLE M3 ; 
	BITS12 D2 ; 
	NYBBLE B2 ; 
	R1 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	M3 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	B2 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	D2 = DisASM_getHalf_char_p_short_int ( exprP , 12 ) ; 
	exprP += 3 ; 
	TString *  str = TString_char_p ( DisASM_opVecStr [ opCode ] ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) " " ) ) ; 
	str -> append_short_int ( str , ( ( short int ) R1 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) ",B'" ) ) ; 
	str -> append_String ( str , DisASM_printBin4_unsigned_byte ( ( unsigned byte ) M3 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "'," ) ) ; 
	str -> append_short_int ( str , ( ( short int ) D2 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "(" ) ) ; 
	str -> append_short_int ( str , ( ( short int ) B2 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) ")" ) ) ; 
	return str ; 
	
} 

TString *  TFormatRS2_assemble_unsigned_byte_char_p ( struct FormatRS2 * this , unsigned byte opCode , char * exprP ) { 
	NYBBLE R1 = 0 ; 
	NYBBLE R3 = 0 ; 
	BITS12 D2 = 0 ; 
	NYBBLE B2 = 0 ; 
	R1 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	R3 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	D2 = DisASM_fetchD_void_p_p ( & exprP ) ; 
	B2 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	TString *  str = DisASM_printHex8_unsigned_byte ( opCode ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) R1 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) R3 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) B2 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex12_short_int ( ( short int ) D2 ) ) ; 
	return str ; 
	
} 

void FormatRS2_static_ ( ) { 
	TFormat *  f = FormatRS2_form = TFormatRS2_ ( ) ; 
	char * * opVecStr = DisASM_opVecStr ; 
	TFormat *  * opVecForm = DisASM_opVecForm ; 
	opVecStr[0xBD] = "CLM";
			opVecForm[0xBD] = f;

			opVecStr[0xBE] = "STCM";
			opVecForm[0xBE] = f;

			opVecStr[0xBF] = "ICM";
			opVecForm[0xBF] = f;
		 
} 

void FormatRS2_finally_ ( ) { 
	FormatRS2_form -> finalize_ ( FormatRS2_form ) ; 
	
} 
/* Instanciates a new FormatRS2. */
TFormatRS2 * TFormatRS2_ ( ) {
	TFormatRS2 * this = TFormatRS20 ( ) ; 
	FormatRS2__ ( this ) ; 
	return this ; 
} 
void FormatRS2__ ( struct FormatRS2 * this ) { 
	Format__ ( ( TFormat * ) this ) ; 
} 
