//Defining class FormatRX0
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Assembly Studio for MVS
 * Copyright 2004 Frdric Brown
 */
/*
 *  This file is part of Assembly Studio for MVS.
 *
 *  Assembly Studio for MVS is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Assembly Studio for MVS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with Assembly Studio for MVS; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
//Import the class moka.lang.System
//Import the class moka.lang.String
/**
 * Format OpCode R1,D2(X2,B2)
 *
 * @author  Frdric Brown
 */
TFormatRX0 * TFormatRX00 ( ) {
	TFormatRX0 * this = malloc ( sizeof ( TFormatRX0 ) ) ; 
	this -> class = ( char * ) "FormatRX0" ; 
	this -> class_id = 7 ; 
	this -> super = ( void * ) Format ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	this -> finalize_ = ( void * ) TObject_finalize_ ; 
	//Methods from class Format
	//Methods from class FormatRX0
	this -> print_unsigned_byte_char_p = ( void * ) TFormatRX0_print_unsigned_byte_char_p ; 
	this -> assemble_unsigned_byte_char_p = ( void * ) TFormatRX0_assemble_unsigned_byte_char_p ; 
	return this ; 
} 

TString *  TFormatRX0_print_unsigned_byte_char_p ( struct FormatRX0 * this , unsigned byte opCode , char * exprP ) { 
	NYBBLE R1 ; 
	BITS12 D2 ; 
	NYBBLE X2 ; 
	NYBBLE B2 ; 
	R1 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	X2 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	B2 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	D2 = DisASM_getHalf_char_p_short_int ( exprP , 12 ) ; 
	exprP += 3 ; 
	TString *  str = TString_char_p ( DisASM_opVecStr [ opCode ] ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) " " ) ) ; 
	str -> append_short_int ( str , ( ( short int ) R1 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "," ) ) ; 
	str -> append_short_int ( str , ( ( short int ) D2 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "(" ) ) ; 
	str -> append_short_int ( str , ( ( short int ) X2 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "," ) ) ; 
	str -> append_short_int ( str , ( ( short int ) B2 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) ")" ) ) ; 
	return str ; 
	
} 

TString *  TFormatRX0_assemble_unsigned_byte_char_p ( struct FormatRX0 * this , unsigned byte opCode , char * exprP ) { 
	NYBBLE R1 = 0 ; 
	BITS12 D2 = 0 ; 
	NYBBLE X2 = 0 ; 
	NYBBLE B2 = 0 ; 
	R1 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	D2 = DisASM_fetchD_void_p_p ( & exprP ) ; 
	X2 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	B2 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	TString *  str = DisASM_printHex8_unsigned_byte ( opCode ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) R1 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) X2 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) B2 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex12_short_int ( ( short int ) D2 ) ) ; 
	return str ; 
	
} 

void FormatRX0_static_ ( ) { 
	TFormat *  f = FormatRX0_form = TFormatRX0_ ( ) ; 
	char * * opVecStr = DisASM_opVecStr ; 
	TFormat *  * opVecForm = DisASM_opVecForm ; 
	opVecStr[0x40] = "STH";
			opVecForm[0x40] = f;

			opVecStr[0x41] = "LA";
			opVecForm[0x41] = f;

			opVecStr[0x42] = "STC";
			opVecForm[0x42] = f;

			opVecStr[0x43] = "IC";
			opVecForm[0x43] = f;

			opVecStr[0x44] = "EX";
			opVecForm[0x44] = f;

			opVecStr[0x45] = "BAL";
			opVecForm[0x45] = f;

			opVecStr[0x46] = "BCT";
			opVecForm[0x46] = f;

			opVecStr[0x47] = "BC";
			opVecForm[0x47] = f;

			opVecStr[0x48] = "LH";
			opVecForm[0x48] = f;

			opVecStr[0x49] = "CH";
			opVecForm[0x49] = f;

			opVecStr[0x4A] = "AH";
			opVecForm[0x4A] = f;

			opVecStr[0x4B] = "SH";
			opVecForm[0x4B] = f;

			opVecStr[0x4C] = "MH";
			opVecForm[0x4C] = f;

			opVecStr[0x4D] = "BAS";
			opVecForm[0x4D] = f;

			opVecStr[0x4E] = "CVD";
			opVecForm[0x4E] = f;

			opVecStr[0x4F] = "CVB";
			opVecForm[0x4F] = f;

			opVecStr[0x50] = "ST";
			opVecForm[0x50] = f;

			opVecStr[0x54] = "N";
			opVecForm[0x54] = f;

			opVecStr[0x55] = "CL";
			opVecForm[0x55] = f;

			opVecStr[0x56] = "O";
			opVecForm[0x56] = f;

			opVecStr[0x57] = "X";
			opVecForm[0x57] = f;

			opVecStr[0x58] = "L";
			opVecForm[0x58] = f;

			opVecStr[0x59] = "C";
			opVecForm[0x59] = f;

			opVecStr[0x5A] = "A";
			opVecForm[0x5A] = f;

			opVecStr[0x5B] = "S";
			opVecForm[0x5B] = f;

			opVecStr[0x5C] = "M";
			opVecForm[0x5C] = f;

			opVecStr[0x5D] = "D";
			opVecForm[0x5D] = f;

			opVecStr[0xD6] = "OC";
			opVecForm[0xD6] = f;
		 
} 

void FormatRX0_finally_ ( ) { 
	FormatRX0_form -> finalize_ ( FormatRX0_form ) ; 
	
} 
/* Instanciates a new FormatRX0. */
TFormatRX0 * TFormatRX0_ ( ) {
	TFormatRX0 * this = TFormatRX00 ( ) ; 
	FormatRX0__ ( this ) ; 
	return this ; 
} 
void FormatRX0__ ( struct FormatRX0 * this ) { 
	Format__ ( ( TFormat * ) this ) ; 
} 
