//Defining class FormatSS1
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Assembly Studio for MVS
 * Copyright 2004 Frdric Brown
 */
/*
 *  This file is part of Assembly Studio for MVS.
 *
 *  Assembly Studio for MVS is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Assembly Studio for MVS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with Assembly Studio for MVS; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
//Import the class moka.lang.System
//Import the class moka.lang.String
/**
 * Format OpCode D1(L1,B1),D2(L2,B2)
 *
 * @author  Frdric Brown
 */
TFormatSS1 * TFormatSS10 ( ) {
	TFormatSS1 * this = malloc ( sizeof ( TFormatSS1 ) ) ; 
	this -> class = ( char * ) "FormatSS1" ; 
	this -> class_id = 10 ; 
	this -> super = ( void * ) Format ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	this -> finalize_ = ( void * ) TObject_finalize_ ; 
	//Methods from class Format
	//Methods from class FormatSS1
	this -> print_unsigned_byte_char_p = ( void * ) TFormatSS1_print_unsigned_byte_char_p ; 
	this -> assemble_unsigned_byte_char_p = ( void * ) TFormatSS1_assemble_unsigned_byte_char_p ; 
	return this ; 
} 

TString *  TFormatSS1_print_unsigned_byte_char_p ( struct FormatSS1 * this , unsigned byte opCode , char * exprP ) { 
	BITS12 D1 ; 
	NYBBLE L1 ; 
	NYBBLE B1 ; 
	BITS12 D2 ; 
	NYBBLE L2 ; 
	NYBBLE B2 ; 
	L1 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	L2 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	B1 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	D1 = DisASM_getHalf_char_p_short_int ( exprP , 12 ) ; 
	exprP += 3 ; 
	B2 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	D2 = DisASM_getHalf_char_p_short_int ( exprP , 12 ) ; 
	exprP += 3 ; 
	TString *  str = TString_char_p ( DisASM_opVecStr [ opCode ] ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) " " ) ) ; 
	str -> append_short_int ( str , ( ( short int ) D1 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "(" ) ) ; 
	str -> append_short_int ( str , ( ( short int ) ++ L1 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "," ) ) ; 
	str -> append_short_int ( str , ( ( short int ) B1 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) ")," ) ) ; 
	str -> append_short_int ( str , ( ( short int ) D2 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "(" ) ) ; 
	str -> append_short_int ( str , ( ( short int ) ++ L2 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "," ) ) ; 
	str -> append_short_int ( str , ( ( short int ) B2 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) ")" ) ) ; 
	return str ; 
	
} 

TString *  TFormatSS1_assemble_unsigned_byte_char_p ( struct FormatSS1 * this , unsigned byte opCode , char * exprP ) { 
	BITS12 D1 ; 
	NYBBLE L1 ; 
	NYBBLE B1 ; 
	BITS12 D2 ; 
	NYBBLE L2 ; 
	NYBBLE B2 ; 
	D1 = DisASM_fetchD_void_p_p ( & exprP ) ; 
	L1 = ( unsigned byte ) DisASM_fetchL_void_p_p ( & exprP ) ; 
	B1 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	D2 = DisASM_fetchL_void_p_p ( & exprP ) ; 
	L2 = ( unsigned byte ) DisASM_fetchL_void_p_p ( & exprP ) ; 
	B2 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	TString *  str = DisASM_printHex8_unsigned_byte ( opCode ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) -- L1 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) -- L2 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) B1 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex12_short_int ( ( short int ) D1 ) ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) B2 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex12_short_int ( ( short int ) D2 ) ) ; 
	return str ; 
	
} 

void FormatSS1_static_ ( ) { 
	TFormat *  f = FormatSS1_form = TFormatSS1_ ( ) ; 
	char * * opVecStr = DisASM_opVecStr ; 
	TFormat *  * opVecForm = DisASM_opVecForm ; 
	opVecStr[0xF2] = "PACK";
			opVecForm[0xF2] = f;

			opVecStr[0xF3] = "UNPK";
			opVecForm[0xF3] = f;

			opVecStr[0xF8] = "ZAP";
			opVecForm[0xF8] = f;

			opVecStr[0xF9] = "CP";
			opVecForm[0xF9] = f;

			opVecStr[0xFA] = "AP";
			opVecForm[0xFA] = f;

			opVecStr[0xFB] = "SP";
			opVecForm[0xFB] = f;

			opVecStr[0xFC] = "MP";
			opVecForm[0xFC] = f;

			opVecStr[0xFD] = "DP";
			opVecForm[0xFD] = f;
		 
} 

void FormatSS1_finally_ ( ) { 
	FormatSS1_form -> finalize_ ( FormatSS1_form ) ; 
	
} 
/* Instanciates a new FormatSS1. */
TFormatSS1 * TFormatSS1_ ( ) {
	TFormatSS1 * this = TFormatSS10 ( ) ; 
	FormatSS1__ ( this ) ; 
	return this ; 
} 
void FormatSS1__ ( struct FormatSS1 * this ) { 
	Format__ ( ( TFormat * ) this ) ; 
} 
