//Defining class IOStream
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */
/*
 *  This file is part of Moka API.
 *
 *  Moka API is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka API is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Moka API; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * This class represents an Input/Output data stream.
 *
 * @author  Frdric Brown
 * @version 1.0, 2002-10-01
 * @since   MDK1.0a
 */
TIOStream * TIOStream0 ( ) {
	TIOStream * this = malloc ( sizeof ( TIOStream ) ) ; 
	this -> class = ( char * ) "IOStream" ; 
	this -> class_id = 29 ; 
	this -> super = ( void * ) Object ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	//Methods from class IOStream
	this -> finalize_ = ( void * ) TIOStream_finalize_ ; 
	this -> writeChars_char_p = ( void * ) TIOStream_writeChars_char_p ; 
	return this ; 
} 
/**
     * Creates an IOStream.
     */
TIOStream * TIOStream_ ( ) {
	TIOStream * this = TIOStream0 ( ) ; 
	IOStream__ ( this ) ; 
	return this ; 
} 
void IOStream__ ( struct IOStream * this ) { 
	this -> opened = FALSE ; 
	this -> error = FALSE ; 
	
} 
/**
	 * Closes the stream.
	 * Since this method is an abstract one, subclasses of IOStream
	 * must overwrite this method.
     *
	 */
/**
     * Writes a buffer of bytes up to the specified length.
	 * Since this method is an abstract one, subclasses of IOStream
	 * must overwrite this method.
     *
     * @param	buffer the buffer of bytes to be written
     * @param	len the specified length
     */
/**
     * Frees the memory of system ressources used by this IOStream
     * object.  If the stream is opened, it will be closed first.
     */
void TIOStream_finalize_ ( struct IOStream * this ) { 
	if ( this -> opened ) { 
		this -> close_ ( this ) ; 
		
	} 
	free(this);
		 
} 
/**
	 * Writes an ANSI string.
	 @param val the ANSI string to be written
	*/
void TIOStream_writeChars_char_p ( struct IOStream * this , char * val ) { 
	short int len = strlen(val)  ; 
	this -> writeBytes_char_p_short_int ( this , val , len ) ; 
	
} 
