//Defining class OptionPane
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */
/*
 *  This file is part of Moka API.
 *
 *  Moka API is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka API is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Moka API; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * <code>OptionPane</code> makes it easy to pop up a standard dialog box that
 * prompts users for a value or informs them of something.
 *
 * @author  Frdric Brown
 * @version 1.0, 2002-11-13
 * @since   MDK1.0a
 */
TOptionPane * TOptionPane0 ( ) {
	TOptionPane * this = malloc ( sizeof ( TOptionPane ) ) ; 
	this -> class = ( char * ) "OptionPane" ; 
	this -> class_id = 19 ; 
	this -> super = ( void * ) Frame ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	//Methods from class EventListener
	//Methods from class Component
	this -> setBounds_short_int_short_int_short_int_short_int = ( void * ) TComponent_setBounds_short_int_short_int_short_int_short_int ; 
	this -> setY_short_int = ( void * ) TComponent_setY_short_int ; 
	this -> move_short_int_short_int = ( void * ) TComponent_move_short_int_short_int ; 
	this -> center_ = ( void * ) TComponent_center_ ; 
	//Methods from class Container
	this -> onPaint_ = ( void * ) TContainer_onPaint_ ; 
	this -> onRefresh_ = ( void * ) TContainer_onRefresh_ ; 
	this -> repaintChildren_ = ( void * ) TContainer_repaintChildren_ ; 
	this -> paintChildren_SCR_RECT_p = ( void * ) TContainer_paintChildren_SCR_RECT_p ; 
	this -> checkMnemonic_char = ( void * ) TContainer_checkMnemonic_char ; 
	this -> add_Component = ( void * ) TContainer_add_Component ; 
	this -> remove_Component = ( void * ) TContainer_remove_Component ; 
	this -> toFront_Component = ( void * ) TContainer_toFront_Component ; 
	this -> clean_ = ( void * ) TContainer_clean_ ; 
	//Methods from class Frame
	this -> finalize_ = ( void * ) TFrame_finalize_ ; 
	this -> use_ = ( void * ) TFrame_use_ ; 
	this -> isCursorOverCloseButton_short_int_short_int = ( void * ) TFrame_isCursorOverCloseButton_short_int_short_int ; 
	this -> isCursorOverMinimizeButton_short_int_short_int = ( void * ) TFrame_isCursorOverMinimizeButton_short_int_short_int ; 
	this -> isCursorOverTitleBar_short_int_short_int = ( void * ) TFrame_isCursorOverTitleBar_short_int_short_int ; 
	this -> onClose_ = ( void * ) TFrame_onClose_ ; 
	this -> onMinimize_ = ( void * ) TFrame_onMinimize_ ; 
	this -> onDrag_ = ( void * ) TFrame_onDrag_ ; 
	this -> dispose_ = ( void * ) TFrame_dispose_ ; 
	this -> setVisible_BOOL = ( void * ) TFrame_setVisible_BOOL ; 
	this -> paint_ = ( void * ) TFrame_paint_ ; 
	this -> paintForeground_ = ( void * ) TFrame_paintForeground_ ; 
	this -> isCursorOver_short_int_short_int = ( void * ) TFrame_isCursorOver_short_int_short_int ; 
	this -> setCaption_String = ( void * ) TFrame_setCaption_String ; 
	this -> setFont_short_int = ( void * ) TFrame_setFont_short_int ; 
	//Methods from class OptionPane
	this -> eventTriggered_Object = ( void * ) TOptionPane_eventTriggered_Object ; 
	return this ; 
} 
/**
 	 * Constructs a newly allocated OptionPane dialog.
 	 */
TOptionPane * TOptionPane_ ( ) {
	TOptionPane * this = TOptionPane0 ( ) ; 
	OptionPane__ ( this ) ; 
	return this ; 
} 
void OptionPane__ ( struct OptionPane * this ) { 
	Frame__ ( ( TFrame *  ) this ) ; 
	this -> minimizeButtonVisible = FALSE ; 
	this -> modal = TRUE ; 
	this -> defaultCloseOperation = Frame_HIDE_ON_CLOSE ; 
	this -> setBounds_short_int_short_int_short_int_short_int ( this , 0 , 0 , 150 , 75 ) ; 
	this -> setFont_short_int ( this , Font_FONT_6x8 ) ; 
	//GEM.gem.add(this); 
	this -> btnOk = TButton_String ( TString_char_p ( ( char * ) "Ok" ) ) ; 
	this -> btnOk -> setBounds_short_int_short_int_short_int_short_int ( this -> btnOk , 2 , 57 , 25 , 16 ) ; 
	this -> btnOk -> mnemonic = 'O' ; 
	this -> btnOk -> listen = this ; 
	this -> add_Component ( this , this -> btnOk ) ; 
	this -> btnYes = TButton_String ( TString_char_p ( ( char * ) "Yes" ) ) ; 
	this -> btnYes -> setBounds_short_int_short_int_short_int_short_int ( this -> btnYes , 2 , 57 , 30 , 16 ) ; 
	this -> btnYes -> mnemonic = 'Y' ; 
	this -> btnYes -> listen = this ; 
	this -> add_Component ( this , this -> btnYes ) ; 
	this -> btnNo = TButton_String ( TString_char_p ( ( char * ) "No" ) ) ; 
	this -> btnNo -> setBounds_short_int_short_int_short_int_short_int ( this -> btnNo , 34 , 57 , 25 , 16 ) ; 
	this -> btnNo -> mnemonic = 'N' ; 
	this -> btnNo -> listen = this ; 
	this -> add_Component ( this , this -> btnNo ) ; 
	this -> btnCancel = TButton_String ( TString_char_p ( ( char * ) "Cancel" ) ) ; 
	this -> btnCancel -> setBounds_short_int_short_int_short_int_short_int ( this -> btnCancel , 61 , 57 , 52 , 16 ) ; 
	this -> btnCancel -> mnemonic = 'C' ; 
	this -> btnCancel -> listen = this ; 
	this -> add_Component ( this , this -> btnCancel ) ; 
	this -> text = TTextField_ ( ) ; 
	this -> text -> setBounds_short_int_short_int_short_int_short_int ( this -> text , 2 , 32 , 146 , 16 ) ; 
	this -> text -> setFont_short_int ( this -> text , Font_FONT_6x8 ) ; 
	this -> add_Component ( this , this -> text ) ; 
	this -> message = TLabel_ ( ) ; 
	this -> message -> setFont_short_int ( this -> message , Font_FONT_6x8 ) ; 
	this -> message -> setBounds_short_int_short_int_short_int_short_int ( this -> message , 2 , 14 , 146 , 14 ) ; 
	this -> add_Component ( this , this -> message ) ; 
	this -> option = OptionPane_DEFAULT_OPTION ; 
	this -> value = NULL ; 
	
} 
/**
 	 * Called at the end of the program to free the
 	 * ressources used by the static members of this class.
 	 */
void OptionPane_finally_ ( ) { 
	if ( OptionPane_dialog ) { 
		OptionPane_dialog -> dispose_ ( OptionPane_dialog ) ; 
		
	} 
	
} 
/**
 	 * Reinitializes the components of the OptionPane.
 	 */
void OptionPane_prepare_ ( ) { 
	if ( ! OptionPane_dialog ) { 
		OptionPane_dialog = TOptionPane_ ( ) ; 
		
	} 
	OptionPane_dialog -> repaint = TRUE ; 
	OptionPane_dialog -> btnOk -> visible = FALSE ; 
	OptionPane_dialog -> btnYes -> visible = FALSE ; 
	OptionPane_dialog -> btnNo -> visible = FALSE ; 
	OptionPane_dialog -> btnCancel -> visible = FALSE ; 
	OptionPane_dialog -> text -> visible = FALSE ; 
	
} 
/**
     * Shows a question-message dialog requesting input from the user. The 
     * dialog will be centered on the screen.
     *
     * @param message The question-message to be displayed.
     */
TString *  OptionPane_showInputDialog_String ( struct String * message ) { 
	return OptionPane_showInputDialog_Container_String_String ( ( TContainer *  ) NULL , TString_char_p ( ( char * ) "Input" ) , message ) ; 
	
} 
/**
     * Shows a question-message dialog requesting input from the user. The 
     * dialog will be centered on its parent.
     *
     * @param parent The parent of the dialog.
     * @param title The title of the dialog.
     * @param message The question-message to be displayed.
     */
TString *  OptionPane_showInputDialog_Container_String_String ( struct Container * parent , struct String * title , struct String * message ) { 
	OptionPane_prepare_ ( ) ; 
	OptionPane_dialog -> setCaption_String ( OptionPane_dialog , title ) ; 
	OptionPane_dialog -> message -> setCaption_String ( OptionPane_dialog -> message , message ) ; 
	OptionPane_dialog -> text -> setCaption_String ( OptionPane_dialog -> text , TString_char_p ( ( char * ) "" ) ) ; 
	OptionPane_dialog -> btnOk -> visible = TRUE ; 
	OptionPane_dialog -> btnCancel -> visible = TRUE ; 
	OptionPane_dialog -> text -> visible = TRUE ; 
	/*if (OptionPane.dialog.parent) {
			OptionPane.dialog.parent.remove(OptionPane.dialog);
		}*/ 
	if ( ! parent ) { 
		GEM_gem -> add_Component ( GEM_gem , OptionPane_dialog ) ; 
		
	} 
	else { 
		parent -> add_Component ( parent , OptionPane_dialog ) ; 
		
	} 
	OptionPane_dialog -> center_ ( OptionPane_dialog ) ; 
	OptionPane_dialog -> value = NULL ; 
	OptionPane_dialog -> setVisible_BOOL ( OptionPane_dialog , TRUE ) ; 
	OptionPane_dialog -> parent -> remove_Component ( OptionPane_dialog -> parent , OptionPane_dialog ) ; 
	return OptionPane_dialog -> value ; 
	
} 
/**
     * Invoked when an event is triggered.
     *
     * @param sender The object who triggered the event.
     */
void TOptionPane_eventTriggered_Object ( struct OptionPane * this , struct Object * sender ) { 
	if ( sender == this -> btnOk ) { 
		if ( this -> text -> visible ) { 
			this -> value = this -> text -> caption -> toString_ ( this -> text -> caption ) ; 
			
		} 
		else { 
			this -> option = OptionPane_OK_OPTION ; 
			
		} 
		
	} 
	else if ( sender == this -> btnYes ) { 
		this -> option = OptionPane_YES_OPTION ; 
		
	} 
	else if ( sender == this -> btnNo ) { 
		this -> option = OptionPane_NO_OPTION ; 
		
	} 
	else if ( sender == this -> btnCancel ) { 
		if ( this -> text -> visible ) { 
			this -> value = NULL ; 
			
		} 
		else { 
			this -> option = OptionPane_CANCEL_OPTION ; 
			
		} 
		
	} 
	else { 
		return ; 
		
	} 
	this -> setVisible_BOOL ( this , FALSE ) ; 
	
} 
