//Defining class Long
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */
/*
 *  This file is part of Moka API.
 *
 *  Moka API is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka API is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Moka API; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * The Long class wraps a value of the primitive type <code>long</code>
 * in an object. An object of type <code>long</code> contains a
 * single field whose type is <code>long</code>.
 * <p>
 * In addition, this class provides several methods for converting
 * an <code>long</code> to a <code>String</code> and a
 * <code>String</code> to an <code>long</code>, as well as other
 * constants and methods useful when dealing with an
 * <code>long</code>.
 * <p>
 *
 * @author  Frdric Brown
 * @version 1.0, 2002-08-29
 * @since   MDK1.0a
 */
/**
     * Checks if the specified string is a decimal representation
     * of a long integer.
     *
     * @param str The string to verify
     * @return true if the specified string is a decimal representation of a long integer, false otherwize.
     */
BOOL Long_isLong_String ( struct String * str ) { 
	short int i ; 
	short int len = ( strlen(str->value)  ) ; 
	if ( len > 20 || len > 19 && str -> value [ 0 ] != '-' ) { 
		return FALSE ; 
		
	} 
	for ( i = 0 ; 
	i < len ; 
	i ++ ) { 
		if ( Character_isDigit_char ( ( char ) str -> value [ i ] ) || i == 0 && str -> value [ i ] == '-' ) { 
			continue ; 
			
		} 
		return FALSE ; 
		
	} 
	return TRUE ; 
	
} 
