//Defining class Menu
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2003 Frdric Brown
 */
/*
 *  This file is part of Moka API.
 *
 *  Moka API is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka API is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Moka API; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 *  Menu class represents a pull-down menu component that is deployed from a menu bar.
 *
 * Each item in a menu must belong to the MenuItem class.
 *
 * @author  Frdric Brown
 * @version 1.0, 2003-10-12
 * @since   MDK2.1
 */
TMenu * TMenu0 ( ) {
	TMenu * this = malloc ( sizeof ( TMenu ) ) ; 
	this -> class = ( char * ) "Menu" ; 
	this -> class_id = 26 ; 
	this -> super = ( void * ) Label ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	//Methods from class EventListener
	//Methods from class Component
	this -> eventTriggered_Object = ( void * ) TComponent_eventTriggered_Object ; 
	this -> setBounds_short_int_short_int_short_int_short_int = ( void * ) TComponent_setBounds_short_int_short_int_short_int_short_int ; 
	this -> setY_short_int = ( void * ) TComponent_setY_short_int ; 
	this -> move_short_int_short_int = ( void * ) TComponent_move_short_int_short_int ; 
	this -> isCursorOver_short_int_short_int = ( void * ) TComponent_isCursorOver_short_int_short_int ; 
	this -> center_ = ( void * ) TComponent_center_ ; 
	this -> toFront_Component = ( void * ) TComponent_toFront_Component ; 
	this -> clean_ = ( void * ) TComponent_clean_ ; 
	this -> checkMnemonic_char = ( void * ) TComponent_checkMnemonic_char ; 
	//Methods from class CaptionedComponent
	this -> setCaption_String = ( void * ) TCaptionedComponent_setCaption_String ; 
	this -> setFont_short_int = ( void * ) TCaptionedComponent_setFont_short_int ; 
	//Methods from class Label
	//Methods from class Menu
	this -> finalize_ = ( void * ) TMenu_finalize_ ; 
	this -> paint_ = ( void * ) TMenu_paint_ ; 
	this -> add_MenuItem = ( void * ) TMenu_add_MenuItem ; 
	this -> onPaint_ = ( void * ) TMenu_onPaint_ ; 
	this -> setVisible_BOOL = ( void * ) TMenu_setVisible_BOOL ; 
	this -> use_ = ( void * ) TMenu_use_ ; 
	return this ; 
} 
/**
	 * Frees the memory of system ressources used by this Menu
	 * object.
	 */
void TMenu_finalize_ ( struct Menu * this ) { 
	TObject *  o ; 
	//An Object reference 
	while ( this -> items -> size ) { 
		//While the list is not empty 
		o = this -> items -> array [ 0 ] ; 
		//Assing the item 0 of the list to o 
		this -> items -> remove_long_int ( this -> items , 0 ) ; 
		//Remove the first item 
		o -> finalize_ ( o ) ; 
		//Finalize o 
		
	} 
	this -> items -> finalize_ ( this -> items ) ; 
	Label -> finalize_ ( this ) ; 
	
} 
/*
	 * Constructs a new Menu specifying its caption.
	 *
	 * @param caption the Menu's caption.
	 */
TMenu * TMenu_String ( struct String * caption ) {
	TMenu * this = TMenu0 ( ) ; 
	Menu__String ( this , caption ) ; 
	return this ; 
} 
void Menu__String ( struct Menu * this , struct String * caption ) { 
	Label__String ( ( TLabel *  ) this , caption ) ; 
	this -> items = TVector_ ( ) ; 
	
} 
/**
	 * Paints the Menu.
	 */
void TMenu_paint_ ( struct Menu * this ) { 
Label->paint_(this);

		DrawLine(this->width - 1, 0, this->width - 1, this->height - 2, A_SHADE_PS);
	
} 
/**
	 * Adds the specified MenuItem to this Menu.
	 * Same as this Menu items.add(i);
	 *
	 * @param i the MenuItem to add to this Menu.
	 */
void TMenu_add_MenuItem ( struct Menu * this , struct MenuItem * i ) { 
	this -> items -> push_Object ( this -> items , i ) ; 
	
} 
/**
	 * Called when a PaintEvent occurs to paint the image of the container and
	 * stores it in its virtual memory.  The container is painted, then all its
	 * children are and finally its foreground is.  A PaintEvent occurs when the
	 * aspect of the container is altered or any of its children is.
	 */
void TMenu_onPaint_ ( struct Menu * this ) { 
	if ( instanceof ( ( TObject * ) this -> parent , ( TObject * ) MenuBar ) ) { 
		( ( TMenuBar *  ) this -> parent ) -> update_ ( ( ( TMenuBar *  ) this -> parent ) ) ; 
		
	} 
	Label -> onPaint_ ( this ) ; 
	
} 
/**
	 * Sets the visibility of the component.
	 *
	 * @param b true if the component should be visible, false otherwize.
	 */
void TMenu_setVisible_BOOL ( struct Menu * this , BOOL b ) { 
	Label -> setVisible_BOOL ( this , b ) ; 
	if ( instanceof ( ( TObject * ) this -> parent , ( TObject * ) MenuBar ) ) { 
		( ( TMenuBar *  ) this -> parent ) -> update_ ( ( ( TMenuBar *  ) this -> parent ) ) ; 
		
	} 
	
} 
/**
	 * This method is invoked by the GEM when the user interacts
	 * with the ComboBox.
	 */
void TMenu_use_ ( struct Menu * this ) { 
short i;
		TContainer* ct = this->parent;
		short y = this->y;
		short x = this->x;
		short height = GEM_getFontHeight_short_int(this->font) + 4;
		short x0;
		short y0;
		short x1;
		short y1;
		short max;
		short key;
		short h = GEM_getFontHeight_short_int(this->font);
		short w = GEM_getFontWidth_short_int(this->font);
		TMenuItem* item;
		void* begin;
		void* end;
		long int pos;
		long int len;
		long int maxLen = 0;
		short boxWidth;

		if (!this->enabled) {
			return;
		}

		if (this->items->size < 1) {
			CaptionedComponent->use_((TCaptionedComponent*)this);
			return;
		}


		while (ct) {
			y = y + ct->y;
			x = x + ct->x;
			ct = ct->parent;
		}

		for (i = 0; i < this->items->size; i++) {
			len = strlen(((TMenuItem*)this->items->array[i])->caption->value);

			if (len > maxLen) maxLen = len;
		}

		if (this->items->size * height + y + this->height <= GEM_USABLE_HEIGHT) {
			x0 = x;
			y0 = y + this->height;
			x1 = x + this->width - 1;
			y1 = y0 + this->items->size * height + 2;

		}
		else if (this->items->size * height - y - 2 < 0) {
			x0 = x;
			y0 = y - 2 - this->items->size * height;
			x1 = x + this->width - 1;
			y1 = y-2;
		}
		else {
			x0 = x;
			y0 = 0;
			x1 = x + this->width - 1;
			y1 = this->items->size * height + 1;
		}

		boxWidth = (maxLen * w + 4);

		if (boxWidth < GEM_LCD_WIDTH) {
			x1 = x0 + boxWidth;
		}
		else {
			x1 = GEM_LCD_WIDTH - 1;
		}

		if ((x0 + boxWidth) >= GEM_LCD_WIDTH) {
			if (x + this->width - 1 - boxWidth >= 0 && (x + this->width - 1 < GEM_LCD_WIDTH)) {
				x0 = x + this->width - 1 - boxWidth;
				x1 = x + this->width - 1;

			}
			else {
				x0 = 0;
				x1 = boxWidth;
			}

		}

		ScrRectFill(&(SCR_RECT){{x, y-1, x+this->width-3, y+this->height-1}}, ScrRect, A_XOR);
		ScrRectFill(&(SCR_RECT){{x0 + 1, y0 + 1, x1 - 1, y1 - 1}}, ScrRect, A_REVERSE);

		if (this->font != Font_FONT_SYSTEM) {
			FontSetSys(this->font);
		}

		max = (y1 - y0) / height;

		for (i = 0; i < this->items->size && i < max; i++) {

			item = (TMenuItem*)this->items->array[i];

			DrawStr(x0 + 2, y0 + 2 + i * height, item->caption->value, A_NORMAL);

			begin = item->caption->value;
			len = strlen(item->caption->value);
			end = memchr(begin, item->mnemonic, len);


			if (!end) {
				end = memchr(begin, Character_toLowerCase_char(item->mnemonic), len);
			}

			if (end) {
				pos = (long int)((char*)end - (char*)begin);
				DrawLine(x0 + 2 + w * pos, y0 + 3 + i * height + h , x0 + 2 + w * (pos + 1), y0 + 3 + i * height + h, A_NORMAL);
			}
		}

		if (this->font != Font_FONT_SYSTEM) {
			FontSetSys(GEM_gem->systemFont);
		}

		//DrawClipRect (&(WIN_RECT){x0, y0,  x1, y1}, ScrRect, A_NORMAL);

		DrawLine ( x0 , y0 , x1 , y0 , A_NORMAL ) ;
		DrawLine ( x0 , y0 , x0 , y1 , A_NORMAL ) ;
		DrawLine ( x0 , y1 , x1 , y1 , A_NORMAL ) ;
		DrawLine ( x1 , y0 , x1 , y1 , A_NORMAL ) ;

		key = GEM_gem->useCursor_(GEM_gem);

		if (key == KEY_ENTER) {
			if (GEM_gem->cursorY >= y0 && GEM_gem->cursorY <= y1 && GEM_gem->cursorX >= x0 && GEM_gem->cursorX <= x1) {
				i = (GEM_gem->cursorY - y0) / (GEM_getFontHeight_short_int(this->font) + 4);
				if (i < this->items->size && ((TMenuItem*)this->items->array[i])->listen) {
						((TMenuItem*)this->items->array[i])->listen->eventTriggered_Object(((TMenuItem*)this->items->array[i])->listen, this->items->array[i]);
				}
			}
		}
		else {
			for (i = 0; i < this->items->size; i++) {
				if (((TMenuItem*)this->items->array[i])->mnemonic == key && ((TMenuItem*)this->items->array[i])->listen) {
						((TMenuItem*)this->items->array[i])->listen->eventTriggered_Object(((TMenuItem*)this->items->array[i])->listen, this->items->array[i]);
				}
			}
		}

		CaptionedComponent->use_((TCaptionedComponent*)this);

		GEM_gem->repaint = TRUE;
	
} 
