//Defining class MenuBar
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2003 Frdric Brown
 */
/*
 *  This file is part of Moka API.
 *
 *  Moka API is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka API is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Moka API; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * The MenuBar class represents a menu bar bound to a frame. In order to associate the menu bar with a Frame object, call the frame's setMenuBar method. 
 *
 * @author  Frdric Brown
 * @version 1.0, 2003-10-12
 * @since   MDK2.1
 */
TMenuBar * TMenuBar0 ( ) {
	TMenuBar * this = malloc ( sizeof ( TMenuBar ) ) ; 
	this -> class = ( char * ) "MenuBar" ; 
	this -> class_id = 21 ; 
	this -> super = ( void * ) Container ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	//Methods from class EventListener
	//Methods from class Component
	this -> finalize_ = ( void * ) TComponent_finalize_ ; 
	this -> eventTriggered_Object = ( void * ) TComponent_eventTriggered_Object ; 
	this -> paint_ = ( void * ) TComponent_paint_ ; 
	this -> setBounds_short_int_short_int_short_int_short_int = ( void * ) TComponent_setBounds_short_int_short_int_short_int_short_int ; 
	this -> setY_short_int = ( void * ) TComponent_setY_short_int ; 
	this -> move_short_int_short_int = ( void * ) TComponent_move_short_int_short_int ; 
	this -> setVisible_BOOL = ( void * ) TComponent_setVisible_BOOL ; 
	this -> isCursorOver_short_int_short_int = ( void * ) TComponent_isCursorOver_short_int_short_int ; 
	this -> center_ = ( void * ) TComponent_center_ ; 
	//Methods from class Container
	this -> onPaint_ = ( void * ) TContainer_onPaint_ ; 
	this -> onRefresh_ = ( void * ) TContainer_onRefresh_ ; 
	this -> repaintChildren_ = ( void * ) TContainer_repaintChildren_ ; 
	this -> paintChildren_SCR_RECT_p = ( void * ) TContainer_paintChildren_SCR_RECT_p ; 
	this -> use_ = ( void * ) TContainer_use_ ; 
	this -> checkMnemonic_char = ( void * ) TContainer_checkMnemonic_char ; 
	this -> add_Component = ( void * ) TContainer_add_Component ; 
	this -> remove_Component = ( void * ) TContainer_remove_Component ; 
	this -> toFront_Component = ( void * ) TContainer_toFront_Component ; 
	this -> clean_ = ( void * ) TContainer_clean_ ; 
	//Methods from class MenuBar
	this -> paintForeground_ = ( void * ) TMenuBar_paintForeground_ ; 
	this -> add_Menu = ( void * ) TMenuBar_add_Menu ; 
	this -> update_ = ( void * ) TMenuBar_update_ ; 
	return this ; 
} 

/**
	 * Constructs a newly allocated MenuBar.
	 */
TMenuBar * TMenuBar_ ( ) {
	TMenuBar * this = TMenuBar0 ( ) ; 
	MenuBar__ ( this ) ; 
	return this ; 
} 
void MenuBar__ ( struct MenuBar * this ) { 
	Container__ ( ( TContainer *  ) this ) ; 
	//this.pos = 2; 
	
} 
/**
	 * Paints the foreground of the MenuBar.
	 */
void TMenuBar_paintForeground_ ( struct MenuBar * this ) { 
DrawLine(0, this->height-1, this->width-1, this->height-1, A_NORMAL);
	
} 
/**
	 * Adds the specified Menu to this MenuBar.
	 *
	 * @param m the Menu to add to this MenuBar.
	 */
void TMenuBar_add_Menu ( struct MenuBar * this , struct Menu * m ) { 
	this -> add_Component ( this , ( TComponent *  ) m ) ; 
	this -> update_ ( this ) ; 
	
} 
/**
	 * Updates the disposition of the Menus on the Menubar.
	 */
void TMenuBar_update_ ( struct MenuBar * this ) { 
	short int width ; 
	short int pos = 0 ; 
	TComponent *  c = this -> child ; 
	TMenu *  m ; 
	while ( c ) { 
		if ( ( instanceof ( ( TObject * ) c , ( TObject * ) Menu ) ) && c -> visible ) { 
			m = ( TMenu *  ) c ; 
			width = GEM_getFontWidth_short_int ( m -> font ) * strlen ( m->caption->value ) ; 
			if ( width > GEM_LCD_WIDTH - 2 ) { 
				width = GEM_LCD_WIDTH - 3 ; 
				
			} 
			if ( m -> x != pos || m -> y != 1 || m -> width != ( width + 2 ) || m -> height != 13 ) { 
				m -> setBounds_short_int_short_int_short_int_short_int ( m , pos , 1 , width + 2 , 13 ) ; 
				
			} 
			pos += width + 4 ; 
			
		} 
		c = c -> next ; 
		
	} 
	
} 
