//Package moka.io
/*
 * This file contains the structure of all the classes of the package, the declaration of all the method of these classes and all their static attributes.
 */
//Structure of class File
typedef struct File { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct File * ) ; 
	void ( * finalize_ ) ( struct File * ) ; 
	//Fields from class IOStream
/** Is the stream opened ? Should be only read.*/
	BOOL opened ; 
/** Is the stream in error ? Should be only read.*/
	BOOL error ; 
	//Methods from class IOStream
	void ( * close_ ) ( struct File * ) ; 
	void ( * writeBytes_char_p_short_int ) ( struct File * , char * , short int ) ; 
	void ( * writeChars_char_p ) ( struct File * , char * ) ; 
	//Fields from class File
/** The FILE structure encapsulated. */
	FILE * file ; 
/** The file mode. Should be only read.*/
	short int mode ; 
/** The name of the file. Should be only read.*/
	struct String * name ; 
/** The type of the file to appear in the VAR-LINK menu.*/
	struct String * type ; 
	//Methods from class File
	void ( * open_short_int ) ( struct File * , short int ) ; 
	long int ( * available_ ) ( struct File * ) ; 
	short int ( * readBytesCount_char_p_short_int ) ( struct File * , char * , short int ) ; 
} TFile ; 
struct File * TFile0 ( ) ; 
struct File * File ; //Generic File object prototype
/** A char pointer used by the showVarLinkDialog method.*/
char*  File_varBuffer ; 
/** Open for reading only (binary).*/
#define File_MODE_OPEN_READ 0 
/** Create for writing (binary). If a file by that name already exists, it will be overwritten.*/
#define File_MODE_WRITE 1 
/** Append (binary); open for writing at end of file, or create for writing if the file does not exist.*/
#define File_MODE_APPEND 2 
/** Open an existing file for update (reading and writing) (binary).*/
#define File_MODE_OPEN_UPDATE 3 
/** Create a new file for update (reading and writing) (binary). If a file by that name already exists, it will be overwritten.*/
#define File_MODE_UPDATE 4 
/** Open for append (binary); open for update at the end of the file, or create if the file does not exist.*/
#define File_MODE_UPDATE_APPEND 5 
/** Open for reading only (text).*/
#define File_MODE_OPEN_READ_TEXT 6 
/** Create for writing (text). If a file by that name already exists, it will be overwritten.*/
#define File_MODE_WRITE_TEXT 7 
/** Append (text); open for writing at end of file, or create for writing if the file does not exist.*/
#define File_MODE_APPEND_TEXT 8 
/** Open an existing file for update (reading and writing) (text).*/
#define File_MODE_OPEN_UPDATE_TEXT 9 
/** Create a new file for update (reading and writing) (text). If a file by that name already exists, it will be overwritten.*/
#define File_MODE_UPDATE_TEXT 10 
/** Open for append (text); open for update at the end of the file, or create if the file does not exist.*/
#define File_MODE_UPDATE_APPEND_TEXT 11 
struct File * TFile_String ( struct String * ) ; 
void File__String ( struct File * , struct String * ) ; 
struct File * File_showVarLinkDialog_ ( ) ; 
void TFile_open_short_int ( struct File * , short int ) ; 
void TFile_close_ ( struct File * ) ; 
long int TFile_available_ ( struct File * ) ; 
void TFile_writeBytes_char_p_short_int ( struct File * , char * , short int ) ; 
short int TFile_readBytesCount_char_p_short_int ( struct File * , char * , short int ) ; 
void TFile_finalize_ ( struct File * ) ; 
//Structure of class Keyboard
typedef struct Keyboard { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Keyboard * ) ; 
	void ( * finalize_ ) ( struct Keyboard * ) ; 
	//Fields from class Keyboard
/* Various flags to indicate which keys are pressed.*/
	byte key_Diamnd ; 

	byte key_Shift ; 

	byte key_2nd ; 

	byte key_APPS ; 

	byte key_ESC ; 

	byte key_Right ; 

	byte key_Down ; 

	byte key_Left ; 

	byte key_Up ; 

	byte key_ENTER ; 

	byte key_ENTER1 ; 

	byte key_ENTER2 ; 

	byte key_F1 ; 

	byte key_F2 ; 

	byte key_F3 ; 

	byte key_F4 ; 

	byte key_F5 ; 

	byte key_A ; 

	byte key_B ; 

	byte key_C ; 

	byte key_D ; 

	byte key_E ; 

	byte key_F ; 

	byte key_G ; 

	byte key_H ; 

	byte key_I ; 

	byte key_J ; 

	byte key_K ; 

	byte key_L ; 

	byte key_M ; 

	byte key_N ; 

	byte key_O ; 

	byte key_P ; 

	byte key_Q ; 

	byte key_R ; 

	byte key_S ; 

	byte key_T ; 

	byte key_U ; 

	byte key_V ; 

	byte key_W ; 

	byte key_X ; 

	byte key_Y ; 

	byte key_Z ; 
	//Methods from class Keyboard
} TKeyboard ; 
/** The BACKSPACE key. */
#define Keyboard_KEY_BACKSPACE KEY_BACKSPACE 
/** The CLEAR key. */
#define Keyboard_KEY_CLEAR KEY_CLEAR 
/** The VARLNK key. */
#define Keyboard_KEY_VARLNK KEY_VARLNK 
/** The ENTER key. */
#define Keyboard_KEY_ENTER KEY_ENTER 
//Structure of class RowRead
typedef struct RowRead { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct RowRead * ) ; 
	void ( * finalize_ ) ( struct RowRead * ) ; 
	//Fields from class RowRead
	//Methods from class RowRead
} TRowRead ; 

short int RowRead_RR_R_2ND ; 

short int RowRead_RR_C_2ND ; 

short int RowRead_RR_R_APPS ; 

short int RowRead_RR_C_APPS ; 

short int RowRead_RR_R_RIGHT ; 

short int RowRead_RR_C_RIGHT ; 

short int RowRead_RR_R_DOWN ; 

short int RowRead_RR_C_DOWN ; 

short int RowRead_RR_R_LEFT ; 

short int RowRead_RR_C_LEFT ; 

short int RowRead_RR_R_UP ; 

short int RowRead_RR_C_UP ; 

short int RowRead_RR_R_ENTER1 ; 

short int RowRead_RR_C_ENTER1 ; 

short int RowRead_RR_R_ENTER2 ; 

short int RowRead_RR_C_ENTER2 ; 

short int RowRead_RR_R_F4 ; 

short int RowRead_RR_C_F4 ; 

INT_HANDLER RowRead_save_int_1 ; 

INT_HANDLER RowRead_save_int_5 ; 

/* Alias implemented */
#define RowRead_key_2nd RowRead_RR_R_2ND RowRead_RR_C_2ND 

/* Alias implemented */
#define RowRead_key_APPS RowRead_RR_R_APPS RowRead_RR_C_APPS 

/* Alias implemented */
#define RowRead_key_Right RowRead_RR_R_RIGHT RowRead_RR_C_RIGHT 

/* Alias implemented */
#define RowRead_key_Down RowRead_RR_R_DOWN RowRead_RR_C_DOWN 

/* Alias implemented */
#define RowRead_key_Left RowRead_RR_R_LEFT RowRead_RR_C_LEFT 

/* Alias implemented */
#define RowRead_key_Up RowRead_RR_R_UP RowRead_RR_C_UP 

/* Alias implemented */
#define RowRead_key_ENTER RowRead_key_ENTER1 RowRead_key_ENTER2 

/* Alias implemented */
#define RowRead_key_ENTER1 RowRead_RR_R_ENTER1 RowRead_RR_C_ENTER1 

/* Alias implemented */
#define RowRead_key_ENTER2 RowRead_RR_R_ENTER2 RowRead_RR_C_ENTER2 

/* Alias implemented */
#define RowRead_key_F4 RowRead_RR_R_F4 RowRead_RR_C_F4 

/* Alias implemented */
#define RowRead_key_ANY 0 
void RowRead_enable_ ( ) ; 
void RowRead_disable_ ( ) ; 
//Structure of class IOStream
typedef struct IOStream { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct IOStream * ) ; 
	void ( * finalize_ ) ( struct IOStream * ) ; 
	//Fields from class IOStream
/** Is the stream opened ? Should be only read.*/
	BOOL opened ; 
/** Is the stream in error ? Should be only read.*/
	BOOL error ; 
	//Methods from class IOStream
	void ( * close_ ) ( struct IOStream * ) ; 
	void ( * writeBytes_char_p_short_int ) ( struct IOStream * , char * , short int ) ; 
	void ( * writeChars_char_p ) ( struct IOStream * , char * ) ; 
} TIOStream ; 
struct IOStream * TIOStream0 ( ) ; 
struct IOStream * IOStream ; //Generic IOStream object prototype
struct IOStream * TIOStream_ ( ) ; 
void IOStream__ ( struct IOStream * ) ; 
void TIOStream_finalize_ ( struct IOStream * ) ; 
void TIOStream_writeChars_char_p ( struct IOStream * , char * ) ; 
//Structure of class Serializable
typedef struct Serializable { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Serializable * ) ; 
	void ( * finalize_ ) ( struct Serializable * ) ; 
	//Fields from class Serializable
	//Methods from class Serializable
} TSerializable ; 
