//Package moka.util
/*
 * This file contains the structure of all the classes of the package, the declaration of all the method of these classes and all their static attributes.
 */
//Structure of class Timer
typedef struct Timer { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Timer * ) ; 
	void ( * finalize_ ) ( struct Timer * ) ; 
	//Fields from class Interrupt
/** A flag to indicate if this timer is registered. */
	BOOL registered ; 
	//Methods from class Interrupt
	BOOL ( * check_ ) ( struct Timer * ) ; 
	void ( * run_ ) ( struct Timer * ) ; 
	//Fields from class Timer

/** Is the timer activated ? Should be only read.*/
	BOOL active ; 
/** The delay of the timer (in 1/20th of second). Should be modified only when the timer is inactive.*/
	long int delay ; 
/** The time stamp value when this timer will expire.*/
	long int time ; 
/** The listener binded to this timer.*/
	struct EventListener * listen ; 
	//Methods from class Timer
} TTimer ; 
/** The current time stamp (in 1/20th of second). Should be only read.*/
volatile long int Timer_timeStamp ; 
void Timer_static_ ( ) ; 
void Timer_wait_long_int ( long int ) ; 
//Structure of class Vector
typedef struct Vector { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Vector * ) ; 
	void ( * finalize_ ) ( struct Vector * ) ; 
	//Fields from class Vector
/** The actual array of objects.*/
	struct Object * * array ; 
/** The actual capacity of the Vector.  Should be only read.*/
	long int capacity ; 
/** The capacity increment of the Vector.  Sould be >= 1.*/
	long int capacityIncrement ; 
/** The actual size of the Vector.  Should be only read.*/
	long int size ; 
	//Methods from class Vector
	void ( * push_Object ) ( struct Vector * , struct Object * ) ; 
	struct Object * ( * remove_long_int ) ( struct Vector * , long int ) ; 
} TVector ; 
struct Vector * TVector0 ( ) ; 
struct Vector * Vector ; //Generic Vector object prototype
struct Vector * TVector_ ( ) ; 
void Vector__ ( struct Vector * ) ; 
struct Vector * TVector_long_int_long_int ( long int , long int ) ; 
void Vector__long_int_long_int ( struct Vector * , long int , long int ) ; 
void TVector_push_Object ( struct Vector * , struct Object * ) ; 
void TVector_finalize_ ( struct Vector * ) ; 
struct Object * TVector_remove_long_int ( struct Vector * , long int ) ; 
struct String * TVector_toString_ ( struct Vector * ) ; 
//Structure of class Enumeration
typedef struct Enumeration { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Enumeration * ) ; 
	void ( * finalize_ ) ( struct Enumeration * ) ; 
	//Fields from class Enumeration
/** The first element of the enumeration.*/
	struct Entry * first ; 
/** The current element.*/
	struct Entry * current ; 
	//Methods from class Enumeration
} TEnumeration ; 
//Structure of class Entry
typedef struct Entry { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Entry * ) ; 
	void ( * finalize_ ) ( struct Entry * ) ; 
	//Fields from class Entry
/**  The object linked to this entry.*/
	struct Object * element ; 
/** The previous entry in the LinkedList.*/
	struct Entry * previous ; 
/** The next entry in the LinkedList.*/
	struct Entry * next ; 
	//Methods from class Entry
} TEntry ; 
struct Entry * TEntry0 ( ) ; 
struct Entry * Entry ; //Generic Entry object prototype
